<?php
/*
 * Copyright (c) 2025 AltumCode (https://altumcode.com/)
 *
 * This software is licensed exclusively by AltumCode and is sold only via https://altumcode.com/.
 * Unauthorized distribution, modification, or use of this software without a valid license is not permitted and may be subject to applicable legal actions.
 *
 * 🌍 View all other existing AltumCode projects via https://altumcode.com/
 * 📧 Get in touch for support or general queries via https://altumcode.com/contact
 * 📤 Download the latest version via https://altumcode.com/downloads
 *
 * 🐦 X/Twitter: https://x.com/AltumCode
 * 📘 Facebook: https://facebook.com/altumcode
 * 📸 Instagram: https://instagram.com/altumcode
 */

namespace Altum\Models;

defined('ALTUMCODE') || die();

class ItemOptions extends Model {

    public function get_item_options_by_store_id_and_item_options_ids($store_id, $item_options_ids) {

        if(!count($item_options_ids)) {
            return [];
        }

        $item_options_ids = implode(',', $item_options_ids);

        $item_options = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_item_options?store_id=' . $store_id . '&item_options_ids=' . $item_options_ids);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $item_options_result = database()->query("
                SELECT 
                    *
                FROM 
                    `items_options` 
                WHERE 
                    `item_option_id` IN ({$item_options_ids}) 
            ");
            while($row = $item_options_result->fetch_object()) $item_options[] = $row;

            cache()->save(
                $cache_instance->set($item_options)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $item_options = $cache_instance->get();

        }

        return $item_options;

    }

}
